//<c>   Copyright 1994-2000 by Gerry J. Danen; all rights reserved.

//<t>   Prepare Batch file to ZIP all subdirs into .ZIP files

#include"gd_tools.h"
#include"gd_extrn.h"
#include"gd_ansi.h"
#include<search.h>


#define pgVERS_ "V3.11"
#define pgTITL_ "Prepare Batch file to ZIP all subdirs"
#define pgCOPR_ "1994"


#if     (! LARGE_MODEL)
  #error LARGE MEMORY MODEL REQUIRED
#endif


#define MAXFLS  10000                           // max number of c/c++ files
#define BUFSIZE 10000
FILE    *fd1, *fd2 ;
UCHAR   fl_2[FS_LEN], work2[BUFSIZE+1], *w2 ;
long    cfound = 0L ;
int     ft_entries=0 ;
UCHAR   cmd[256], *pcmd ;
static  char    *ftable[MAXFLS+1] ;


int     qs_compare( const char **arg1, const char **arg2 )
{
    return( _stricmp( *arg1, *arg2 ) );
}


void    ftable_update( char fname[] )
{
    strcpy( cmd, fname );
    st_reduce_spaces( cmd );
    st_trim( cmd );
    pcmd = strchr( cmd, '.' );
    if ( pcmd != NULL )
        *pcmd = EOS ;
    strupr( cmd );
    if ( strlen(cmd) )
    {
        if ( ft_entries < MAXFLS )
        {
            ftable[ft_entries] = _strdup(cmd);
            if ( ftable[ft_entries] == NULL )
                exit( 3 );
            ft_entries += 1 ;
        }
        else
        {
            printf( "Too many entries in the file table: %s skipped\n", fname );
        }
    }
}


void    write_batch( char fname[] )
{
    cfound += 1L ;
    fprintf( stderr, "\r%ld", cfound );
    strupr ( fname );
    fprintf( fd2, " call s2z %s %ld %d\n", fname, cfound, ft_entries );
}


void    main( int argc, char *argv[] )
{
    char        temp[3] ;
    int         attrib, done ;
    struct find_t dta ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    ansi_cls( 1, stderr );
    logon(1);

    st_cpy( fl_2, "s2z-all.bat", FS_LEN );
    strupr( fl_2 );

    fd2 = fopen( fl_2, "w" );
    if ( fd2 == NULL )
    {
        printf( "Cannot open batch file: %s\n", fl_2 );
        exit( 3 );
    }
    fprintf( fd2,
                "@echo off\n"
                " : Generated by %s %s on %s %s %s\n"
                " : %s\n\n",
             get_global_program_name(), pgm_vers, TodaysDay(), TodaysDate(), TodaysTime(), pgm_copyrite );

    //          count first how many directories to process and load table
    attrib = _A_SUBDIR ;                        // only directories
    done = _dos_findfirst( "*.*", attrib, &dta );
    while ( ! done )
    {
        strncpy(temp,dta.name, 2);
        if ( ((dta.attrib & _A_SUBDIR) == _A_SUBDIR) && (temp[0] != '.') )
            ftable_update( dta.name );
        done = _dos_findnext( &dta );
    }

    qsort( (char *)ftable, (size_t)ft_entries, (size_t)sizeof(char *), qs_compare );

    for ( done=0 ; done<ft_entries ; done++ )   // now write the batch file
        write_batch( ftable[done] );

    _fcloseall();
    fprintf( stderr, "\r%d director%s to zip\n", ft_entries, (ft_entries==1L ? "y" : "ies") );
    exit( 0 );
}
